
Ruby - Bug #15640

Inconsistent value passed to respond_to_missing?

03/06/2019 12:22 AM - kirun (Kieran Leigh)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.5.1p57 (2018-03-29 revision

63029) [x86_64-linux-gnu]

Backport: 2.4: UNKNOWN, 2.5: UNKNOWN, 2.6:

UNKNOWN

Description

If the symbol has been defined, then it is passed. Otherwise a string is passed the first time.

class SomeBug

  def respond_to_missing?(m, *)

    p m

    true

  end

end



if false then

  # uncomment to force to symbol--location doesn't matter, just the literal parse:

  # :aa

end



sd = SomeBug.new



# NOTE: single character strings do not show this behavior

sd.method("aa".to_sym)       # "aa" unless :aa uncommented above

sd.method("aa".to_sym)       # :aa

sd.method("bb".to_sym)       # "bb"

sd.method("bb".to_sym)       # :bb

Associated revisions

Revision 7fed9a2df50404c734504e0405ecaa98f0d9147c - 03/06/2019 11:16 AM - nobu (Nobuyoshi Nakada)

proc.c: call respond_to_missing? with a symbol

[ruby-core:91683] [Bug #15640]
History

#1 - 03/06/2019 10:22 AM - nobu (Nobuyoshi Nakada)

- Description updated

Good catch.
This behavior was to get rid of inadvertent symbol creation before symbol-GC,

so it is no longer needed.

#2 - 03/06/2019 10:40 AM - Hanmac (Hans Mackowiak)

@nobu (Nobuyoshi Nakada) should the value depending on the value used for method, or should respond_to_missing? always has Symbol as

parameter?

i think the best would be to make it simple and always have it use Symbol

#3 - 03/06/2019 11:16 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset trunk|r67185.

proc.c: call respond_to_missing? with a symbol
